Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa08w.bas
'*
'* aISA-R08
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/27
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA08_DLL_NAME = "aisa08.dll"  ' DLLt@C
Global Const AISA08_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa08.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa08wDllOpen() As Boolean

    Aisa08wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA08_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa08wGetDllExportFunc() = False Then
        Aisa08wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa08wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa08.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa08wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa08wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa08wDllClose = True
        Exit Function
    End If
    
    Aisa08wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-R08 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True       --- 
'*          False      --- s
'*****************************************************************************
Function Aisa08wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa08wGetVersion = 0
        Exit Function
    End If
    
    If Aisa08GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa08wGetVersion = True
    Else
        Aisa08wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R08̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa08wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa08wCreate = False
        Exit Function
    End If
    
    If Aisa08Create(pwLogSlot) <> 0 Then
        Aisa08wCreate = True
    Else
        Aisa08wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R08̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa08wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa08wClose = False
        Exit Function
    End If
    
    If Aisa08Close(wLogSlot) <> 0 Then
        Aisa08wClose = True
    Else
        Aisa08wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa08wGetResource(wLogSlot As Integer, pResInfo As AISA08RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa08wGetResource = False
        Exit Function
    End If
    
    If Aisa08GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa08wGetResource = True
    Else
        Aisa08wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa08wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa08wOutPort = False
        Exit Function
    End If
    
    If Aisa08OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa08wOutPort = True
    Else
        Aisa08wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-R08̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa08wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa08wGetLastError = AISA08_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa08wGetLastError = Aisa08GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa08wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa08wGetDllExportFunc = False
    
    ' Aisa08GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa08Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa08Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08Close")
    If pFunc = 0 Then Exit Function

    ' Aisa08GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa08OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa08GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa08GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa08wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
